--- include get.e (using rncget.e)
sequence int,bmp
integer width,height,null,pointer

global function gfxread(sequence filename)
    pointer=0
    int={}
    null=open(filename,"rb") -- Open the file and read
        while pointer != -1 do
            pointer=getc(null)
            int=append(int,pointer)
        end while
    close(null)
    bmp={}
    pointer=2
    for ax=1 to int[pointer-1] do -- Loop for each image
        width=int[pointer]*10+int[pointer+1] -- Set width
        height=int[pointer+2]*10+int[pointer+3] -- Set height
        bmp=append(bmp,repeat({},height))
        pointer=pointer+4
        null=length(bmp)
        for y=1 to height do -- Create the BMP
            bmp[null][y]=int[pointer..pointer+width]
            pointer=pointer+width
        end for
    end for           
    return bmp
end function
global function readpal(sequence filename)
    bmp=repeat({0,0,0},256)
    null=open(filename,"rb") -- Open the file and read

    if null <1 then  -- file not found !
        puts(1,"\n\n")
        puts(1,"\n  O arquivo " & filename & " foi alterado ou no existe,")
        puts(1,"\n  reinstale esse jogo.\n")
        cursor(UNDERLINE_CURSOR)
        abort(1)
    end if

    pointer=0
    int={}
        while pointer != -1 do
            pointer=getc(null)
            int=append(int,pointer)
        end while
    close(null)                     
    pointer=1
    for ax=1 to 256 do
        for dx=1 to 3 do
            bmp[ax][dx]=int[pointer]
            pointer=pointer+1
        end for
    end for
    return bmp
end function

