global constant FontWidth=repeat( -- this is the width of each font
{6,6,6,6,6,5,6,6,6,4,4,6,4,5,5,5,7,6,6,5,3,6,6,5,3,3,3,6,6,3,6,6,4,4,4,5,7,9,
6,6,10,3,8,6,5,6,6,5,5,6,4,6,6,7,5,9,3,5,4,3,5,6,5,6,6,6,6,6,9,7,7,7,7,6,7,7,
6,8,6,8,6,7,6,6,6,3,6,8,6,6,6,7,6,8,6},4)
global procedure and_image(sequence s1, sequence s2)
   integer w
   w=length(s2[1])
   for r=1 to length(s2) do
      pixel(and_bits(s2[r],get_pixel({s1[1],s1[2]+r-1,w})), {s1[1],s1[2]+r-1})
   end for
end procedure
global procedure merge_image(sequence s1, sequence s2)
    ------- This procedure is from Jiri Jabor's "gt.e"
   sequence s
   integer co,w
   w=length(s2[1])
   for r=1 to length(s2) do
      s=get_pixel({s1[1],s1[2]+r-1,w}) -- get background row
      for c=1 to w do
         co=s2[r][c]
         if co then s[c]=co end if
      end for
      pixel(s, {s1[1],s1[2]+r-1})
   end for
end procedure
global function abs(integer a)
    if a<0 then return -a else return a end if
end function
global function CropBmp(sequence a,sequence b,sequence bmp)
    sequence TmpCropBmp
    integer crH,crV
    TmpCropBmp=repeat(repeat(0,b[1]-a[1]+1),b[2]-a[2]+1)
    crH=1 crV=1
    for ah=a[2] to b[2] do
        for av=a[1] to b[1] do
            TmpCropBmp[crH][crV]=bmp[ah][av]
            crV=crV+1
        end for
        crH=crH+1 crV=1
    end for
    return TmpCropBmp
end function                                            
global function GrabBmp(sequence bmp,sequence pos,sequence size)
    sequence finalbmp
    finalbmp=repeat({},length(bmp))
    for ay=1 to size[2] do
        finalbmp[ay]=bmp[ay+pos[2]-1][pos[1]..pos[1]+size[1]-1]
    end for
    return finalbmp
end function
global function DumpFont(sequence bmp,integer idx,integer color)
    sequence final
    integer pointer
    pointer=1
    final=repeat(repeat({},length(bmp)),length(FontWidth[idx]))
    for ax=1 to length(final) do
        final[ax]=GrabBmp(bmp,{pointer,1},{FontWidth[idx][ax],length(bmp)})
        pointer=pointer+FontWidth[idx][ax]
    end for
    final = (color * (final = 223)) + (final * (final != 223))
--      s = (newval * (s = keyval)) + (s * (s != keyval))
    return final
end function

