-- If you want to check how buggy computer plays this game, enable
-- the indicated line above:

--global constant POPUP_NEWGAME_TYPE={"Human","Computer"} --< With Computer
global constant POPUP_NEWGAME_TYPE={"Human"} --< Without Computer (recommended)


----- After Jiri's message I decided to post the source code of my game.
-- Some variables are in portuguese (or mixed with english terms) because
-- i'm from Brazil (so, since I'm only 16, and english is not my natural
-- language, forgive my english mistakes....)
-- I tried to comment some parts of the code, but you will have to pay a lot
-- of attention to understand everything.
-- Some of the AI code have already been started, but a nasty bug appeared 
-- somewhere, so I got tired of this project and started another (I think a 
-- lot of people do this: start one project, halt, do another, get back to
-- that old one......)
-- My web page is at http://www.infolink.com.br/~rnc/ 
-- (go to the english version)
-- I will be very happy if someone write the AI code for me, or fix some
-- of the bugs it has...

without warning
without type_check

-------------------------- Global Definitions -------------------------------

global integer nill,CanUseSounds,nill2,nill3,UseSounds,
                MouseX,MouseY,MouseB
global sequence AppDir,MouseBuf,GfxBmp,GamePallete,Button,StatusBuf,
                StatusText,ButtonDiz

             
global constant true=1,false=0

UseSounds=true -- if this machine are going to use sounds
CanUseSounds=true -- if this machine supports sounds

---------------------------------- Includes ----------------------------------

include rncimage.e -- mixture of image.e and graphics.e with some changes
include rncget.e -- get.e
include readgfx.e -- my engine for saving and reading all the graphics
include rncgt.e -- some bitmap routines
include mouse.e -- mouse: by G.Burke
include core.e -- some core routines
include sfx2.e -- by Jacques Deschenes - SB and Wavs support

----------- Get current dir: I know this is useless
AppDir=current_dir() & "\\"
---------------------------------- Definitions ------------------------------
    atom AnimDelay,LastPress,PressDelay
    sequence NillSeq,TmpBmp,Board,Limits,Mask,Tiles,CurBeep,
             MainLogoBuf,Sels,ButtonBuf,ToolBarBuf,ToolBarImg,
             SelectedPos,Score,PlayerType,SkullAnim,ScoreBuf,
             AtualTurnAnim,AIPieces,NewGamePBmpBuf,cmdline,SoundEffects
    integer SairMain,StartMain,SairJogo,AtualTurn,NumPlayers,
            TilesLeft,SairNewGame,StartNewGame,AIIsWorking,AIType,Usevesa
    object Event                                          

    
-- General Game Constants                                  
global constant --- to know the order of the images in TRI.GFX
    BACK2_BMP=1,
    ANIM1_BMP=2,
    FRAME_BMP=3,
    MOUSE_BMP=4,
    TRITILES_BMP=5,
    SMALLBTN_BMP=6,
    PIECE1_BMP=7,
    FONT1_BMP=8,
    BACK1_BMP=9,
    FACE_BMP=10,
    SKLYES_BMP=11,
    SKLNO_BMP=12,
    SKLSPIN_BMP=13,
    SKELET_BMP=14,
    ANIM2_BMP=15,
    BIGPIECE_BMP=16,
    ANIM3_BMP=17,
    MAINLOGO_BMP=18,
-- GUI Constants
    BoardWidth=12,
    BoardHeight=8,
    TileWidth=42,
    TileHeight=50,
    BoardPos={120,10}, -- window position of board
    DizBarPos={16,451}, -- window position of toolbar
    MainLogoPos={145,40},
    ScorePos={10,160},
    PColor={236,219}, 
    SkullPos={30,90},
    NewGamePBmpPos={MainLogoPos+{90,120},MainLogoPos+{260,120}}, 
    WinPos={140,100},
-- Messages & Dialogs Texts
TXT_VERSION="v1.00",
TXT_SOBRE=    {    -- about text
                "     TRI - The first final version of this freeware       ",
                "   game is now done, and if you program in Euphoria,      ",
                "    the source code is also available.                    ",
                "                                                          ",
                "      Check for new versions and updates at               ",
                "                                                          ",
                "          http://www.infolink.com.br/~rnc/                ",
                "                                                          ",
                "      If you are interested on this game and want to      ",
                "   become a beta-tester, or have any comments or doubts,  ",
                "   e-mail me at RNC@BIGFOOT.COM                           ",                
                "                                                          ",
                "      More information on this game can be found on the   ",
                "   file README.TXT                                        ",
                "                                                          ",
                " Additional credits:                                      ",
                "    Jacques Deschenes - Sound Blaster code                ",
                "                                                          "},
TXT_AJUDA= {"   The goal of this game is to try to dominate the      ",
            "   board. When moving one of your pieces, cloning her   ",
            "   or not, to an adjacent triangle to an enemy piece    ",
            "   you dominate her, and she becomes your piece.        ",
            "   When all the triangles are full, the winner will be  ",
            "   the one with more pieces.                            "},
TXT_IDLEDIZ="TRI Dominium " & TXT_VERSION & 
    " -- 1998, by Ricardo Niederberger Cabral -- http://www.infolink.com.br/~rnc/",
TXT_WINNER={{" Congratulations !","",""},
            {" You win !","",""},
            {" Finaly !","",""}},

TXT_EMPATE={{"  Unbelievable, a tie !!!","",""}, -- draw text
            {"  Both win and both lose:", "a   T I E !",""},
            {"  After a long time playing","and a long time thinking:",
             "  You finished on a TIE !"}},
-- Menus and dizs texts
POPUP_YESNO={"Confirm","Cancel"},
POPUPDIZ_YESNO={"Confirm the last action","Cancel the last action"},
-- Buttons and respective dizs
BTN_MAIN={{"Start","Start a new game"},
         {"Help","Some quick information on how to play this game"},
         {"About","More information on this game"},
         {"Exit","Exit this game"}
        },
BTN_GAME={{"Stop","Stop current game"},
          {"Sounds","Set sounds"}},
BTN_NEWGAME={{"Start","Start a game with these options"},
             {"Cancel","Return to the main screen"},
             {"Change","Change the type of player 1"},
             {"Change","Change the type of player 2"}},
-- Misc
NUMFRAMES_SKULL={12,20,20},
AI_EASY=1,AI_MEDDIUM=2,AI_HARD=3, -- ai types
-- Default Boards                 
BRD_TRI={{0,0,0,0,0,1,0,0,0,0,0,0}, -- the board backgroud
         {0,0,0,0,1,2,1,0,0,0,0,0},
         {0,0,0,1,2,1,2,1,0,0,0,0},
         {0,0,1,2,1,2,1,2,1,0,0,0},
         {0,1,2,1,2,1,2,1,2,1,0,0},
         {1,2,1,2,1,2,1,2,1,2,1,0},
         {2,1,2,1,2,1,2,1,2,1,2,0},
         {0,0,0,0,0,0,0,0,0,0,0,0}},

PCE_TRI={{0,0,0,0,0,0,0,0,0,0,0,0}, -- the pieces:
         {0,0,0,0,0,0,0,0,0,0,0,0}, -- 1 - PLayer 1
         {0,0,0,0,0,0,0,0,0,0,0,0}, -- 2 - Player 2
         {0,0,0,0,0,0,0,0,0,0,0,0},
         {0,0,0,0,0,0,0,0,0,0,0,0},
         {0,0,0,0,0,0,0,0,0,0,0,0},
         {1,0,0,0,0,0,0,0,0,0,2,0},
         {0,0,0,0,0,0,0,0,0,0,0,0}}

---------------------------------- Some other includes ----------------------
include trigui.e  -- my GUI, with Popup menus, message boxes....
-----------------------------------------------------------------------------
procedure InitVars() -- Start em' all
    Board=repeat(repeat(1,BoardWidth),BoardHeight)
    Tiles=repeat(repeat(0,BoardWidth),BoardHeight)
    Button=repeat({},50)
    AIPieces={{},{}}
    SkullAnim={}
    AIIsWorking=false
    PlayerType={1,1}
    StartMain=false
    StartNewGame=false
    Sels={{},{}}               
    AnimDelay=1/30 -- User defined !
    AtualTurn=1  -- User defined !
    NumPlayers=2 --  //    //    !
    SelectedPos={0,0}
    TilesLeft=0
    CurBeep={0,0}
    LastPress=time()
    PressDelay=1/4 -- Time allowed between one click and the next one
end procedure
function DumpBmp(sequence bmp,sequence sz,sequence p) -- crop a section
    sequence TmpDump            
    integer tH
    tH=1                                               
    TmpDump=repeat({},sz[2])
    for ah=(p[2]-1)*sz[2]+1 to p[2]*sz[2] do
        TmpDump[tH]=bmp[ah][(p[1]-1)*sz[1]+1..p[1]*sz[1]]
        tH=tH+1
    end for                                                
    return TmpDump
end function
function GetLimits(sequence bmp)
    sequence lims
    lims=repeat({0,0},length(bmp))
    for y=1 to length(bmp) do
        for x=1 to length(bmp[1]) do
            if bmp[y][x] != 0 then lims[y][1]=x exit end if
        end for
        for x=length(bmp[1]) to 1 by -1 do
            if bmp[y][x] != 0 then lims[y][2]=x exit end if        
        end for
    end for                                                        
    return lims
end function
function UnPackSFX()
    integer fn,numsnds,cnt,sz
    sequence Snds,raw
    object hnd
    Snds={}     
    raw={0}
    fn=open(AppDir & "sfx.dat","rb")
    if fn != -1 then
        hnd={}
        while sequence(hnd) do
            hnd=gets(fn)
            if sequence(hnd) then raw=raw & hnd end if
        end while
        raw=raw[2..length(raw)]
        numsnds=raw[1] -- number of wavs in here
        cnt=2+raw[1]*2
        for ax=1 to numsnds do
            sz=raw[ax*2]*255+raw[ax*2+1] -- get the size of file [ax]
            Snds=append(Snds,raw[cnt+1..cnt+sz])
            cnt=cnt+sz
        end for                       
    else
        -- error opening
        abort(1)
    end if
    return Snds
end function

procedure InitSFX()
    sequence Snds,WavInfo
    integer fn

    SoundEffects = {} -- store all sounds
    Snds=UnPackSFX()

    for i = 1 to length(Snds) do
        fn=open(AppDir & "sfx.tsd","wb")
            puts(fn,Snds[i])
        close(fn)
        
        WavInfo = LoadWaveFile(AppDir & "sfx.tsd")
        if sequence(WavInfo) then
            SoundEffects = append(SoundEffects,WavInfo)
            
        else
            UseSounds=false
            puts(1,"\nError reading the sound files")
            puts(1,"\nTry reinstalling this game.")            
            puts(1,"\n\nErro lendo os arquivos de som.")                        
            puts(1,"\nTente reinstalar esse jogo.")
        end if
    end for

end procedure

procedure InitGFX()
        GfxBmp=repeat({},15)
        NillSeq=gfxread(AppDir & "tri.gfx")
-- Initialize palette and read global data
    TmpBmp=NillSeq[BACK1_BMP]
    GamePallete=readpal(AppDir & "tri.pal")
    GfxBmp[1]={TmpBmp,NillSeq[BACK2_BMP]}
-- Get Mouse Gfx
    GfxBmp[2]={NillSeq[MOUSE_BMP]}
-- Fix mouse gfx buf
    GfxBmp[2]={DumpBmp(GfxBmp[2][1],{16,16},{1,1})} -- Mouse is getting width 17 !
    MouseBuf=GfxBmp[2][1]
-- Get board pieces
    GfxBmp[8]={DumpBmp(NillSeq[PIECE1_BMP],{20,20},{2,1}), -- 1,1
               DumpBmp(NillSeq[PIECE1_BMP],{20,20},{1,1})} -- 2,1
-- Get tiles
    nill=floor(length(NillSeq[TRITILES_BMP][1])/8)
    nill2=length(NillSeq[TRITILES_BMP])
    GfxBmp[6]={ {   DumpBmp(NillSeq[TRITILES_BMP],{nill,nill2},{1,1}),
                    DumpBmp(NillSeq[TRITILES_BMP],{nill,nill2},{8,1})    },
                {   DumpBmp(NillSeq[TRITILES_BMP],{nill,nill2},{2,1}),                
                    DumpBmp(NillSeq[TRITILES_BMP],{nill,nill2},{7,1})    },
                {   DumpBmp(NillSeq[TRITILES_BMP],{nill,nill2},{3,1}),                
                    DumpBmp(NillSeq[TRITILES_BMP],{nill,nill2},{6,1})    },
                {   DumpBmp(NillSeq[TRITILES_BMP],{nill,nill2},{4,1}),                
                    DumpBmp(NillSeq[TRITILES_BMP],{nill,nill2},{5,1})    }}
    Limits={{GetLimits(GfxBmp[6][1][1]),GetLimits(GfxBmp[6][1][2])}}
-- Get selected spinning piece anim
    GfxBmp[10]={{},{},{{},{}},{{},{}}}
    -- Piece 1
    GfxBmp[10][1]=repeat({},10)
    for ax=1 to 10 do
        GfxBmp[10][1][ax]=DumpBmp(NillSeq[ANIM1_BMP],{30,30},{ax,1}) 
    end for
    -- Piece 2                 
    GfxBmp[10][2]=repeat({},10)
    for ax=1 to 10 do
        GfxBmp[10][2][ax]=DumpBmp(NillSeq[ANIM1_BMP],{30,30},{ax,2}) 
    end for
-- Get borning anim
    -- gold
    GfxBmp[10][3][1]=repeat({},9) --there are nine frames
    for ax=1 to 9 do
        GfxBmp[10][3][1][ax]=DumpBmp(NillSeq[ANIM2_BMP],{20,20},{ax,1})
    end for
    -- silver
    GfxBmp[10][3][2]=repeat({},9) --there are nine frames
    for ax=1 to 9 do
        GfxBmp[10][3][2][ax]=DumpBmp(NillSeq[ANIM2_BMP],{20,20},{ax,2})
    end for
-- Get morph eating anim
    GfxBmp[10][4][1]=repeat({},6) 
    for ax=1 to 6 do
        GfxBmp[10][4][1][ax]=DumpBmp(NillSeq[ANIM3_BMP],{20,20},{ax,1})
    end for
    GfxBmp[10][4][2]=repeat({},6) 
    for ax=1 to 6 do
        GfxBmp[10][4][2][ax]=GfxBmp[10][4][1][7-ax]
    end for
-- Get skull anim
    GfxBmp[9]={{},{},{}}
    -- Yes
    GfxBmp[9][1]=repeat({},12)
    for ax=1 to 12 do
        GfxBmp[9][1][ax]=DumpBmp(NillSeq[SKLYES_BMP],{50,50},{ax,1})
    end for
    -- No
    GfxBmp[9][2]=repeat({},20)
    for ax=1 to 20 do
        GfxBmp[9][2][ax]=DumpBmp(NillSeq[SKLNO_BMP],{50,50},{ax,1})
    end for
    -- Spin
    GfxBmp[9][3]=repeat({},20)
    for ax=1 to 20 do
            GfxBmp[9][3][ax]=DumpBmp(NillSeq[SKLSPIN_BMP],{50,50},{ax,1})
        end for
-- Get window frame
    TmpBmp=NillSeq[FRAME_BMP]
    GfxBmp[3]={CropBmp({1,1},{8,9},TmpBmp),  --1
              CropBmp({8+1,1},{8+1,6},TmpBmp), --2
              CropBmp({8+2,1},{8+2+8,9},TmpBmp), --3
              CropBmp({1,10},{5,10},TmpBmp), --4          
              CropBmp({8+5,10},{8+8+2,10},TmpBmp), --5          
              CropBmp({1,11},{8,19},TmpBmp), --6          
              CropBmp({8+2,14},{8+2,19},TmpBmp), --7          
              CropBmp({8+2,11},{17,19},TmpBmp)} --8                              
-- Get fonts
    TmpBmp=NillSeq[FONT1_BMP]
    GfxBmp[4]={ DumpFont(TmpBmp,1,223),  --1
                DumpFont(TmpBmp,2,217),  --2
                DumpFont(TmpBmp,3,53),  --3
                DumpFont(TmpBmp,4,233)}  --4
-- Get main big logo
    GfxBmp[7]={NillSeq[MAINLOGO_BMP]}
-- Get buttons
    GfxBmp[5]={NillSeq[SMALLBTN_BMP]}--,NillSeq[GRAYBTN_BMP]} 
-- Get Big Win Pieces,Wrecked and Winner skeletekon
    GfxBmp[12]={{DumpBmp(NillSeq[BIGPIECE_BMP],{150,150},{1,1}),
                 DumpBmp(NillSeq[BIGPIECE_BMP],{150,150},{2,1})},
                 DumpBmp(NillSeq[SKELET_BMP],{150,200},{1,1}),
                 DumpBmp(NillSeq[SKELET_BMP],{150,200},{2,1})}
-- Get new game faces
    GfxBmp[11]={DumpBmp(NillSeq[FACE_BMP],{50,50},{1,1}),
                DumpBmp(NillSeq[FACE_BMP],{50,50},{1,2}),
                DumpBmp(NillSeq[FACE_BMP],{50,50},{1,3}),
                DumpBmp(NillSeq[FACE_BMP],{50,50},{1,4})}
-- Clean vars and free some mem
    TmpBmp={}
    NillSeq={}               
cursor(UNDERLINE_CURSOR)
end procedure
procedure ReadCmdLine()
    cmdline=command_line()
    Usevesa=false
    if length(cmdline)>2 then 
        cmdline=cmdline[3]
        if length(cmdline)=4 then
            if not compare("vesa",cmdline) then
                Usevesa=true
            end if
        end if
    end if
end procedure
procedure InitSVGA()
    if Usevesa=true then UseVesa(1) end if
    if graphics_mode(257) then  --257
        puts(1, "Unable to use the graphics mode of 640 X 480 by 256 colors.\n")
        abort(1)
    end if
    all_palette(GamePallete/4)
    text_color(195)
end procedure
procedure CloseSVGA()
    if graphics_mode(-1) then
    end if
end procedure                               
procedure DrawTiles() -- draw current pieces
    HRMouse_pointer(0)  
    for x=1 to BoardWidth do
        for y=1 to BoardHeight do
            if Tiles[y][x] then
                TilesLeft=TilesLeft-1
                Score[Tiles[y][x]]=Score[Tiles[y][x]]+1
                if Board[y][x]=1 then
                    merge_image(({x,y}-1)*{TileWidth,TileHeight}+
                                 BoardPos+{floor(TileWidth/2),floor(TileHeight/2)},
                    GfxBmp[8][Tiles[y][x]])
                else
                    merge_image(({x,y}-1)*{TileWidth,TileHeight}+
                                 BoardPos+{floor(TileWidth/3)+3,floor(TileHeight/4)},
                    GfxBmp[8][Tiles[y][x]])
                end if
            end if
        end for
    end for
    HRMouse_pointer(1)      
end procedure
procedure DrawBoard() -- draw current board
    sequence t
    Mask=repeat(repeat(0,BoardWidth*TileWidth),BoardHeight*TileHeight)
    TilesLeft=0
    HRMouse_pointer(0)  
    for x=1 to BoardWidth do
        for y=1 to BoardHeight do
            if Board[y][x] then
                TilesLeft=TilesLeft+1
                merge_image(({x,y}-1)*{TileWidth,TileHeight}+BoardPos,
                GfxBmp[6][1][Board[y][x]])
                t=Limits[1][Board[y][x]]
                for dy=1 to length(t) do
Mask[(y-1)*TileHeight+dy][(x-1)*TileWidth+t[dy][1]..(x-1)*TileWidth+t[dy][2]]=
                256*y+x
                end for
            end if
        end for
    end for
    HRMouse_pointer(1)                  
end procedure
function CheckArea() -- check where the mouse is
    if MouseX>BoardPos[1] and MouseX<BoardPos[1]+BoardWidth*TileWidth and
       MouseY>BoardPos[2] and MouseY<BoardPos[2]+BoardHeight*TileHeight then
           return true
    else return false end if    
end function 
function CheckPressedTile() -- return which tile where clicked
    sequence rp
    integer rt

    rp={MouseX,MouseY}-BoardPos
    rt=Mask[rp[2]][rp[1]]
    if rt then
        return {floor(rt/256),rt-floor(rt/256)*256}
    else 
        return {0,0}
    end if
end function
function TellAvailMoves(sequence pos) -- tell which moves are available 
    sequence seq
    integer bg,x,y
    seq={{},{}}
    bg=Board[pos[1]][pos[2]]  
    y=pos[1] x=pos[2]

    if bg=1 then
        if y<BoardHeight then
            if Tiles[y+1][x] =0 and Board[y+1][x] then seq[1]=append(seq[1],{x,y+1}) end if
        end if
    elsif bg=2 then
        if y>1 then
            if Tiles[y-1][x] =0 and Board[y-1][x] then seq[1]=append(seq[1],{x,y-1}) end if
        end if
    end if    
        if x<BoardWidth then
            if Tiles[y][x+1]=0 and Board[y][x+1] then seq[1]=append(seq[1],{x+1,y}) end if
        end if
        if x>1 then
            if Tiles[y][x-1] =0 and Board[y][x-1] then seq[1]=append(seq[1],{x-1,y}) end if
        end if

        if x>1 and y>1 then
            if Tiles[y-1][x-1] =0 and Board[y-1][x-1] then seq[2]=append(seq[2],{x-1,y-1}) end if
        end if
        if x<BoardWidth and y>1 then
            if Tiles[y-1][x+1]=0 and Board[y-1][x+1] then seq[2]=append(seq[2],{x+1,y-1}) end if
        end if
        if x>2 then 
            if Tiles[y][x-2]=0 and Board[y][x-2] then seq[2]=append(seq[2],{x-2,y}) end if
        end if
        if x<BoardWidth-1 then
            if Tiles[y][x+2]=0 and Board[y][x+2] then seq[2]=append(seq[2],{x+2,y}) end if
        end if
        if x<BoardWidth and y<BoardHeight then
            if Tiles[y+1][x+1]=0 and Board[y+1][x+1] then seq[2]=append(seq[2],{x+1,y+1}) end if
        end if
        if x>1 and y<BoardHeight then
            if Tiles[y+1][x-1] =0 and Board[y+1][x-1] then seq[2]=append(seq[2],{x-1,y+1}) end if
        end if
    return seq
end function
function TellEats(sequence pos,integer who)
    integer x,y
    sequence eats 
    eats={}
    x=pos[2] y=pos[1]
    -- common to type 1 & 2
        if x<BoardWidth then
            if Board[y][x+1] and Tiles[y][x+1] and Tiles[y][x+1] != who then
            eats=append(eats,{x+1,y}) end if
        end if
        if x>1 then 
            if Board[y][x-1] and Tiles[y][x-1] and Tiles[y][x-1] != who then
            eats=append(eats,{x-1,y}) end if
        end if
    if Board[y][x]=1 then
        if y<BoardHeight then
            if Board[y+1][x] and Tiles[y+1][x] and Tiles[y+1][x] != who then 
            eats=append(eats,{x,y+1}) end if
        end if
    elsif Board[y][x]=2 then
        if y>1 then
            if Board[y-1][x] and Tiles[y-1][x] and Tiles[y-1][x] != who then
            eats=append(eats,{x,y-1}) end if
        end if
    end if            
    return eats
end function               
procedure UpdatePlacar(integer who) -- update score
    display_image(ScorePos+{10,(who-1)*50+5},ScoreBuf[who])
    BmpPuts(ScorePos+{40,10+(who-1)*50+5},sprintf("%d", Score[who]),1,1)
    if Score[who]>0 then
        Rect(ScorePos+{10,35+(who-1)*50+5},
             ScorePos+{10+Score[who],45+(who-1)*50+5},PColor[who],1)
        Rect(ScorePos+{10,35+(who-1)*50+5},
             ScorePos+{10+Score[who],45+(who-1)*50+5},19,0)
    end if
end procedure

procedure AddPoint(integer who)
    ----- There is something wrong near this procedure
    Score[who]=Score[who]+1    
                               
    UpdatePlacar(who)          
end procedure
procedure TakePoint(integer who) -- take someone's point
    Score[who]=Score[who]-1    
                               
    UpdatePlacar(who)          
end procedure

procedure MoveAnim(sequence poss,sequence pieceskind,integer typo)
    integer x,y
    atom tm
        --- make an animation

    if typo=2 then -- copy 
    x=poss[2][2]    y=poss[2][1]
        HRMouse_pointer(0)  
        if Board[y][x]=1 then 
            for ax=1 to 9 do
                merge_image(({x,y}-1)*{TileWidth,TileHeight}+
                BoardPos+{floor(TileWidth/2),floor(TileHeight/2)},
                GfxBmp[10][3][Tiles[y][x]][ax])
                tm=time()+AnimDelay
                while time()<tm do end while
            end for
            merge_image(({x,y}-1)*{TileWidth,TileHeight}+
            BoardPos+{floor(TileWidth/2),floor(TileHeight/2)},
            GfxBmp[8][Tiles[y][x]])
        else
            for ax=1 to 9 do
                merge_image(({x,y}-1)*{TileWidth,TileHeight}+
                BoardPos+{floor(TileWidth/3)+3,floor(TileHeight/4)},
                GfxBmp[10][3][Tiles[y][x]][ax])
                tm=time()+AnimDelay
                while time()<tm do end while
            end for
            merge_image(({x,y}-1)*{TileWidth,TileHeight}+
            BoardPos+{floor(TileWidth/3)+3,floor(TileHeight/4)},
            GfxBmp[8][Tiles[y][x]])
        end if
        HRMouse_pointer(1)      
    elsif typo=1 then -- move
        HRMouse_pointer(0)  

    x=SelectedPos[2]    y=SelectedPos[1]

        if Board[y][x]=1 then  -- erase the old
            for ax=9 to 1 by -1 do
                merge_image(({x,y}-1)*{TileWidth,TileHeight}+
                BoardPos+{floor(TileWidth/2),floor(TileHeight/2)},
                GfxBmp[10][3][Tiles[y][x]][ax])
                tm=time()+AnimDelay
                while time()<tm do end while
            end for
            merge_image(({x,y}-1)*{TileWidth,TileHeight}+
            BoardPos+{floor(TileWidth/2),floor(TileHeight/2)},
            GfxBmp[8][Tiles[y][x]])
        else
            for ax=9 to 1 by -1 do
                merge_image(({x,y}-1)*{TileWidth,TileHeight}+
                BoardPos+{floor(TileWidth/3)+3,floor(TileHeight/4)},
                GfxBmp[10][3][Tiles[y][x]][ax])
                tm=time()+AnimDelay
                while time()<tm do end while
            end for
            merge_image(({x,y}-1)*{TileWidth,TileHeight}+
            BoardPos+{floor(TileWidth/3)+3,floor(TileHeight/4)},
            GfxBmp[8][Tiles[y][x]])
        end if


        merge_image(({x,y}-1)*{TileWidth,TileHeight}+BoardPos,
        GfxBmp[6][1][Board[y][x]]) -- erase de old place

    x=poss[2][2]    y=poss[2][1]

        if Board[y][x]=1 then  -- draw the new
            for ax=1 to 9 do
                merge_image(({x,y}-1)*{TileWidth,TileHeight}+
                BoardPos+{floor(TileWidth/2),floor(TileHeight/2)},
                GfxBmp[10][3][Tiles[y][x]][ax])
                tm=time()+AnimDelay
                while time()<tm do end while
            end for

            merge_image(({x,y}-1)*{TileWidth,TileHeight}+
            BoardPos+{floor(TileWidth/2),floor(TileHeight/2)},
            GfxBmp[8][Tiles[y][x]])
        else
            for ax=1 to 9 do
                merge_image(({x,y}-1)*{TileWidth,TileHeight}+
                BoardPos+{floor(TileWidth/3)+3,floor(TileHeight/4)},
                GfxBmp[10][3][Tiles[y][x]][ax])
                tm=time()+AnimDelay
                while time()<tm do end while
            end for

            merge_image(({x,y}-1)*{TileWidth,TileHeight}+
            BoardPos+{floor(TileWidth/3)+3,floor(TileHeight/4)},
            GfxBmp[8][Tiles[y][x]])
        end if
        HRMouse_pointer(1)          
    elsif typo=3 then -- eat
    x=poss[2][1]    y=poss[2][2]
        HRMouse_pointer(0)  
        if Board[y][x]=1 then 
            for ax=1 to 6 do
                merge_image(({x,y}-1)*{TileWidth,TileHeight}+
                BoardPos+{floor(TileWidth/2),floor(TileHeight/2)},
                GfxBmp[10][4][pieceskind[1]][ax])
                tm=time()+AnimDelay
                while time()<tm do end while
            end for
           
        else
            for ax=1 to 6 do
                merge_image(({x,y}-1)*{TileWidth,TileHeight}+
                BoardPos+{floor(TileWidth/3)+3,floor(TileHeight/4)},
                GfxBmp[10][4][pieceskind[1]][ax])
                tm=time()+AnimDelay
                while time()<tm do end while
            end for

        end if
        HRMouse_pointer(1)      
    end if
end procedure

procedure Skull(integer typo) -- make a skull animation
    if length(SkullAnim)=0 then
    SkullAnim={typo,1,time()+AnimDelay}
    end if
end procedure

function NextPlayer(integer atual) -- next player's turn
    if atual=NumPlayers then return 1 else return atual+1 end if
end function
function CheckIfLocked(integer who) -- check if a piece can't move
    sequence prob

    for y=1 to length(Tiles) do
    for x=1 to length(Tiles[1]) do
        if Tiles[y][x]=who then
            prob=TellAvailMoves({y,x})
            if length(prob[1])>0 or length(prob[2])>0 then 
            return true end if
        end if
    end for
    end for
    return false
end function
procedure Som(integer idx)
    integer id
    if UseSounds=true then
        id = PlaySound(SoundEffects[idx],0) 
    end if    
end procedure
procedure MakeWin(integer who)  -- show the winning screen
    sequence WinBuf
    integer adver,sortei
    if who=3 then -- tie
        HRMouse_pointer(0)  
        WinBuf=save_image(WinPos,{500,400})
        Frame(WinPos,{500,400},1) -- dialog box
--        merge_image(WinPos+{20,60},GfxBmp[12][4]) --- tie image
        sortei=rand(length(TXT_EMPATE))
        BmpPuts(WinPos+{170,70},TXT_EMPATE[sortei][1],1,1)
        BmpPuts(WinPos+{170,80},TXT_EMPATE[sortei][2],1,1)
        BmpPuts(WinPos+{170,90},TXT_EMPATE[sortei][3],1,1)
    
    else  -- it was not a tie
    if who=1 then adver=2 else adver=1 end if

    HRMouse_pointer(0)  
    WinBuf=save_image(WinPos,{500,400})
    Frame(WinPos,{500,400},1) -- dialog box
    if PlayerType[who]=1 then
        if PlayerType[adver]=1 then
            merge_image(WinPos+{20,60},GfxBmp[12][1][who])
            sortei=rand(length(TXT_WINNER))
            BmpPuts(WinPos+{170,70},TXT_WINNER[sortei][1],1,1)
            BmpPuts(WinPos+{170,80},TXT_WINNER[sortei][2],1,1)
            BmpPuts(WinPos+{170,90},TXT_WINNER[sortei][3],1,1)
        else
            merge_image(WinPos+{20,30},GfxBmp[12][3])        
        end if
    else
            merge_image(WinPos+{20,30},GfxBmp[12][2])                
    end if
    end if
    nill=wait_key()                    
    display_image(WinPos,WinBuf)
    WinBuf={}
    SairMain=true
end procedure

procedure NextTurn() -- do everything that needs to be done on a new turn
    UpdatePlacar(AtualTurn)

    AtualTurn=NextPlayer(AtualTurn)

   if CheckIfLocked(AtualTurn) then--check if there is any possible move
    --        AtualTurn=NextPlayer(AtualTurn)
        Sels={{},{}}
        AtualTurnAnim[AtualTurn][1]=time()+AnimDelay    
        AtualTurnAnim[AtualTurn][2]=1
    else -- Player is locked, there is no more move, the other player wins
        Score[NextPlayer(AtualTurn)]=Score[NextPlayer(AtualTurn)]+TilesLeft

        if Score[1]>Score[2] then nill=1 
        elsif Score[2]>Score[1] then nill=2
        elsif Score[1]=Score[2] then nill=3 end if
        MakeWin(nill)
    end if
end procedure
procedure MakeEat(sequence Source,sequence Dest)

    -- THERE IS A BUG AROUND HERE RELATED TO THE AI !!!!!
    
    sequence eats,todel                                                     
    integer temp
            todel={}
            eats=TellEats(Dest,AtualTurn)
            if length(eats) > 0 then
                Skull(3)    
                for ax=1 to length(eats) do
                    AddPoint(AtualTurn) -- add a point to current player     
                    TakePoint(NextPlayer(AtualTurn))
                    Skull(3)
                    Tiles[eats[ax][2]][eats[ax][1]]=AtualTurn
                    MoveAnim({Source,eats[ax]}, -- init copy anim
                    {Tiles[Source[1]][Source[2]],Tiles[eats[ax][2]][eats[ax][1]]},
                    3) --typo 3=eat
                    if PlayerType[NextPlayer(AtualTurn)]>1 then--AI was eaten
                        todel=append(todel,eats[ax])                    
                    end if
                    if PlayerType[AtualTurn]>1 then--AI is eating
                        AIPieces[AtualTurn]=append(AIPieces[AtualTurn],eats[ax])
                    end if
                end for
            else
                Skull(1)    
            end if                                  
            if length(todel)>0 then -- there are AI pieces eaten, erase them
                for ax=1 to length(todel) do
                    temp=find(todel[ax],AIPieces[NextPlayer(AtualTurn)])

--              if temp and temp<length(AIPieces[NextPlayer(AtualTurn)]) then
if temp then -- debug
                        AIPieces[NextPlayer(AtualTurn)]=    
                        RemoveElement(AIPieces[NextPlayer(AtualTurn)],temp)
end if
--              else
--                        puts(1,"\nSomething weird happened !")
--              end if
                end for
            end if
end procedure
procedure MakeMove(sequence Dest,sequence Source,integer tipo)
if tipo=1 then -- copy
            TilesLeft=TilesLeft-1
            AddPoint(AtualTurn) -- add a point to the current player
            Tiles[Dest[1]][Dest[2]]=AtualTurn
            MoveAnim({Source,Dest}, -- init copy anim
            {Tiles[Source[1]][Source[2]],Tiles[Dest[1]][Dest[2]]},
            2) --typo 2=copy
                ------------- Check for eat code            
            MakeEat(Source,Dest)
                -----------------------------
            NextTurn()
end if
if tipo=2 then -- move
            Tiles[Dest[1]][Dest[2]]=AtualTurn
            MoveAnim({Source,Dest}, -- init copy anim
            {Tiles[Source[1]][Source[2]],Tiles[Dest[1]][Dest[2]]},
            1) --typo 1=move
                ------------- Check for eat code            
            MakeEat(Source,Dest)
                -----------------------------
            Tiles[Source[1]][Source[2]]=0 -- erase source:she moved !
            NextTurn()
end if

end procedure

procedure DoAI(integer Idx)

    -- THERE IS A BUG AROUND HERE RELATED TO THE AI !!!!!

    sequence Movs,tmp,scores,tmp2,newmov,cmov,mmov
    integer pnt_m,pnt_c,maiormov,tmpmaior,tmpmaiorqt
    Movs={}
    cmov={} mmov={}
    for ax=1 to length(AIPieces[Idx]) do
        tmp=TellAvailMoves({AIPieces[Idx][ax][2],AIPieces[Idx][ax][1]})
        pnt_c=0 pnt_m=0
        if length(tmp[1])>0 then -- there are copies
                tmpmaior=1
                tmp2=TellEats({tmp[1][tmpmaior][2],tmp[1][tmpmaior][1]},Idx)
                cmov=tmp[1][tmpmaior]
                tmpmaiorqt=length(tmp2)
            for ex=1 to length(tmp[1]) do -- which copy is better ???
                tmp2=TellEats({tmp[1][ex][2],tmp[1][ex][1]},Idx)
                if length(tmp2)>tmpmaiorqt then tmpmaior=ex 
                                                tmpmaiorqt=length(tmp2) 
                                                cmov=tmp[1][tmpmaior] -- no 1
                                                end if
            end for
            pnt_c=1+tmpmaiorqt
        elsif length(tmp[2])>0 then  -- there are moves
                tmpmaior=1
                tmp2=TellEats({tmp[2][tmpmaior][2],tmp[2][tmpmaior][1]},Idx)
                mmov=tmp[2][tmpmaior]
                tmpmaiorqt=length(tmp2)
            for ex=1 to length(tmp[2]) do -- ver qual copy  melhor
                tmp2=TellEats({tmp[2][ex][2],tmp[2][ex][1]},Idx)
                if length(tmp2)>tmpmaiorqt then tmpmaior=ex 
                                                tmpmaiorqt=length(tmp2) 
                                                mmov=tmp[2][tmpmaior] -- no2
                                                end if
            end for
            pnt_m=tmpmaiorqt
        end if
        if pnt_c>pnt_m then  -- copy works better
                Movs=append(Movs,{ax,pnt_c,1,cmov})
        end if
        if pnt_c<pnt_m then  -- move works better
                Movs=append(Movs,{ax,pnt_c,2,mmov})
        end if
        if pnt_c=pnt_m and pnt_c != 0 then 
                Movs=append(Movs,{ax,pnt_c,1,cmov})
        end if
    end for
    --- check which move goes better
    if length(Movs) then -- are there any possible movs ???
    maiormov=1
    for ax=1 to length(Movs) do
        if length(Movs[ax]) then
           if Movs[ax][2]>Movs[maiormov][2] then maiormov=ax end if
        end if
    end for                             

--------- ATTENTION !  ATTENTION !    --- BUG ---

    newmov={Movs[maiormov][1],Movs[maiormov][3],
--        {Movs[maiormov][4][1][2],Movs[maiormov][4][1][1]}} -- orig
        {Movs[maiormov][4][2],Movs[maiormov][4][1]}} 
    -- pieceidx,tipo,destpos
-------------------------------------- make move code!
        if newmov[2]=1 then -- copy
            AIPieces[Idx]=append(AIPieces[Idx],{newmov[3][2],newmov[3][1]})
            MakeMove(newmov[3],
            {AIPieces[Idx][newmov[1]][2],AIPieces[Idx][newmov[1]][1]},1)
        elsif newmov[2]=2 then -- move
            AIPieces[Idx][newmov[1]]={newmov[3][2],newmov[3][1]}
            MakeMove(newmov[3],
            {AIPieces[Idx][newmov[1]][2],AIPieces[Idx][newmov[1]][1]},2)
        end if    
    end if
end procedure




procedure DrawPlacar()  -- update score
    ScoreBuf={{},{}}
    AtualTurnAnim={{time(),1},{time(),1}}
    for ax=1 to NumPlayers do
        ScoreBuf[ax]=save_image(ScorePos+{10,(ax-1)*50+5},
                                ScorePos+{40,5+(ax-1)*50}+{20,30+20})
        BmpPuts(ScorePos+{40,5+(ax-1)*50+5},sprintf("%d", Score[ax]),1,1)
    end for
end procedure
procedure ClearSels() -- clear board
    integer x,y
    if length(Sels[1]) >0 then
        for ax=1 to length(Sels[1]) do
            x=Sels[1][ax][1]    y=Sels[1][ax][2]
        HRMouse_pointer(0)  
            merge_image(({x,y}-1)*{TileWidth,TileHeight}+BoardPos,
            GfxBmp[6][1][Board[y][x]])
        HRMouse_pointer(1)  
        end for  
    end if                  
    if length(Sels[2]) >0 then
        for ax=1 to length(Sels[2]) do
            x=Sels[2][ax][1]    y=Sels[2][ax][2]
        HRMouse_pointer(0)  
            merge_image(({x,y}-1)*{TileWidth,TileHeight}+BoardPos,
            GfxBmp[6][1][Board[y][x]])
        HRMouse_pointer(1)  
        end for  
    end if                  
end procedure

procedure ProcessPress(sequence pos) -- routine to interpret click
    integer noMoves,noCopies
    sequence eats
    noMoves=false noCopies=false

    if length(Sels[1])+length(Sels[2]) > 0 then -- Is on make move mode
        ClearSels()-- Clear selected cells
        if find({pos[2],pos[1]},Sels[1]) then --Chose a place to copy
            Som(3)
            MakeMove(pos,SelectedPos,1)
            -- Copy code goes here
        elsif find({pos[2],pos[1]},Sels[2]) then -- Chose a place to move
            Som(3)        
            MakeMove(pos,SelectedPos,2)
            -- Move code goes here
        else      
            Sels={{},{}}
            return
        end if
    else 
    if Tiles[pos[1]][pos[2]]=AtualTurn then -- Make a new move
        Sels=TellAvailMoves(pos)
        SelectedPos=pos
        HRMouse_pointer(0)  
        -- Draw current selected piece
--        merge_image(({pos[2],pos[1]}-1)*{TileWidth,TileHeight}+BoardPos,
--        GfxBmp[6][2][Board[pos[1]][pos[2]]])
        -- Draw available moves:
        if length(Sels[1]) > 0 then
                    Som(2)
            for ax=1 to length(Sels[1]) do
        merge_image((Sels[1][ax]-1)*{TileWidth,TileHeight}+BoardPos,
        GfxBmp[6][3][Board[Sels[1][ax][2]][Sels[1][ax][1]]])
            end for                 
        else -- there are no available copies
            noCopies=true
        end if
        if length(Sels[2])>0 then 
            Som(2)        
            for ax=1 to length(Sels[2]) do
        merge_image((Sels[2][ax]-1)*{TileWidth,TileHeight}+BoardPos,
        GfxBmp[6][4][Board[Sels[2][ax][2]][Sels[2][ax][1]]])
            end for
        else -- there are no available moves
            noMoves=true
        end if     
        if noMoves and noCopies then
                Som(1)        
                Skull(3)
            -- no avail moves code here !
        end if                    
                  HRMouse_pointer(1)  
    end if
    end if
end procedure
procedure ProcessGameButton(integer idx)
    integer pnill
    Som(2)
    if idx=1 then
        MouseX=100 MouseY=50
        pnill=PopUp({MouseX,MouseY},POPUP_YESNO,POPUPDIZ_YESNO)
        if pnill=1 then SairMain=true end if
    elsif idx=2 then
    end if
end procedure
procedure UpdateNewGamePBmp(integer idx,integer tip)
    merge_image(NewGamePBmpPos[idx],NewGamePBmpBuf[idx])
    merge_image(NewGamePBmpPos[idx],GfxBmp[11][tip])
end procedure
procedure ProcessNewGameButton(integer idx)
    Som(2)
    if idx=1 then
        StartMain=true
    elsif idx=2 then
        SairNewGame=true

    elsif idx=3 or idx=4 then
        if idx=3 then nill2=1 else nill2=2 end if -- get player
        nill=PopUp({MouseX,MouseY},POPUP_NEWGAME_TYPE,POPUP_NEWGAME_TYPE)
        if nill then -- set player type
            PlayerType[nill2]=nill 
            if nill>1 then -- is a pc
                AIType=nill-1
                UpdateNewGamePBmp(nill2,nill)
            else
                UpdateNewGamePBmp(nill2,1)
            end if
            if nill2=1 then -- p1
                BmpPuts(MainLogoPos+{83,190},POPUP_NEWGAME_TYPE[nill],2,1)
            else --p2
                BmpPuts(MainLogoPos+{240,190},POPUP_NEWGAME_TYPE[nill],2,1)            
            end if
        end if 
    end if
end procedure
procedure ProcessGameMouse()
    integer Mbt1,Mbt2
    sequence sbt1,junk
    Mbt1=0 Mbt2=0
            --- Code for a click
    if MouseB=2 then
        if time()-LastPress>PressDelay then 
            LastPress=time()
            if CheckArea() then
                sbt1=CheckPressedTile()
                if sbt1[1] != 0 then ProcessPress(sbt1) end if
            else
                Mbt1=CheckPressedButton()
                if Mbt1 then ProcessGameButton(Mbt1) end if                    
            end if
        end if
    end if
    if PlayerType[AtualTurn]>1 then DoAI(AtualTurn) end if
    
    -- Code for mouse movement
    if CheckArea() then -- it was on board
         sbt1=CheckPressedTile()
         if sbt1[1] != 0 then
            if Tiles[sbt1[1]][sbt1[2]]=AtualTurn and
               compare(sbt1,CurBeep) then -- is your piece
                junk=TellAvailMoves(sbt1)
                CurBeep=sbt1
                if length(junk[1]) > 0 then
                    Som(5)
                end if
            end if
         else
         end if
    else -- out of board
         Mbt1=CheckPressedButton() 
         if Mbt1 then  -- on a button
            if compare(StatusText,BTN_GAME[Mbt1][2]) then
                 Som(3)
                StatusPut(BTN_GAME[Mbt1][2],1)-- Show button's discript
            end if
         else
            if compare(StatusText,TXT_IDLEDIZ) then -- out of everything
                StatusPut(TXT_IDLEDIZ,2) -- show default diz.
            end if
         end if                    
    end if
end procedure
procedure DoSkullAnim() -- do skull anims
    integer tip
    tip=SkullAnim[1]
    if time() > SkullAnim[3] then
        if SkullAnim[2]=NUMFRAMES_SKULL[tip]+1 then SkullAnim={} return end if
        display_image(SkullPos,GfxBmp[9][tip][SkullAnim[2]])
        SkullAnim[2]=SkullAnim[2]+1
        SkullAnim[3]=time()+AnimDelay
    end if
end procedure
procedure DoAtualTurnAnim() -- do anims
    if time() > AtualTurnAnim[AtualTurn][1] then
        if AtualTurnAnim[AtualTurn][2]=10 then AtualTurnAnim[AtualTurn][2]=1 end if
        merge_image(ScorePos+{10,(AtualTurn-1)*50+5},
                GfxBmp[10][AtualTurn][AtualTurnAnim[AtualTurn][2]])
        AtualTurnAnim[AtualTurn][1]=time()+2*AnimDelay
        AtualTurnAnim[AtualTurn][2]=AtualTurnAnim[AtualTurn][2]+1
    end if
end procedure                                     
procedure DrawMainMenu()
    display_image({1,1},ImgMount(GfxBmp[1][1],640,800))
 
    ToolBarBuf=save_image({10,10},{110,370})
--    Frame({10,10},{100,188},1) -- Options Bar
    Frame({10,10},{100,154},1) -- Options Bar
--    Frame(ScorePos,{100,440},1) -- Score Bar
    Frame(DizBarPos-6,{630,476},1) -- Diz Bar

    MainLogoBuf=save_image(MainLogoPos,{640,480})

--    display_image(MainLogoPos,GfxBmp[7][1]) -- Big Main Logo Image-orig
    merge_image(MainLogoPos,GfxBmp[7][1]) -- Big Main Logo Image-orig
    StatusBuf=save_image(DizBarPos+{3,3},{620,470}) -- Init Status buffer

    -- Draw buttons
    for ax=1 to length(BTN_MAIN) do
        DrawButton({25,30+(ax-1)*30},BTN_MAIN[ax][1],BTN_MAIN[ax][2],ax)
    end for

        ToolBarImg=save_image({20,20},{90,350}) -- get options bar image

    -- Inital diz text
    StatusPut(TXT_IDLEDIZ,2)
end procedure
procedure InitAI()
    AIPieces={{},{}}
    for ax=1 to 2 do -- inicializa AI vars
        if PlayerType[ax]>1 then
            for y=1 to length(Tiles) do
            for x=1 to length(Tiles[1]) do
                if Tiles[y][x]=ax then
                    AIPieces[ax]=append(AIPieces[ax],{x,y})
                end if
            end for
            end for
        end if
    end for
end procedure

procedure Main()         -- Main routine !!!!!!!!!!
    object code     
    sequence MainBuf
    integer keyc
---------------------------- Initializing code
    ButtonBuf=Button
    ResetButtons()
    HRMouse_pointer(0)  
    MainBuf=save_image({MainLogoPos[1]-30,1},{640,450})
    display_image({10,10},ToolBarBuf) -- Clear the options bar
    Frame({10,10},{100,155},1) -- Options Bar
    Frame(ScorePos,{100,280},1) -- Score Bar

    -- Draw options bar buttons
    DrawButton({25,30},BTN_GAME[1][1],BTN_GAME[1][2],1)
--    DrawButton({25,60},BTN_GAME[2][1],BTN_GAME[2][2],2) -- with  sounds

    -- Vars reset
    display_image(SkullPos,GfxBmp[9][1][1])
    Score=repeat(0,NumPlayers)
    TilesLeft=0
    AtualTurn=1
---------------------------- Board Drawing code
    display_image(MainLogoPos,MainLogoBuf) -- Clean Main logo
    HRMouse_pointer(1)  
        -- Set boards
    Board=BRD_TRI 
    Tiles=PCE_TRI
       -- Initialize AI
    InitAI()
       -- Draw boards
    DrawBoard()
    DrawTiles()
    DrawPlacar()
    UpdatePlacar(1)    UpdatePlacar(2)
    StatusPut(TXT_IDLEDIZ,2) -- show default diz

--------- Check to see if someone starts already locked
   if not CheckIfLocked(AtualTurn) then
   
        if Score[1]>Score[2] then nill=1 
        elsif Score[2]>Score[1] then nill=2
        elsif Score[1]=Score[2] then nill=3 end if
        MakeWin(nill)
    end if

-----------------------------
    SairMain=false
    while SairMain=false do 
            ------------- Do Jobs
            if length(SkullAnim) > 0 then DoSkullAnim() end if
            DoAtualTurnAnim()
            ------------- End Do Jobs
            Event=HRM() --  Update pointer, get events 
        -------- Key reading
        keyc= get_key()
        if keyc = 27 then 
            MouseX=100 MouseY=100
            ProcessGameButton(1)
        end if
        -------- Mouse
        if sequence(Event) then
            MouseX=Event[2]
            MouseY=Event[3]
            MouseB=Event[1]
        end if
            ProcessGameMouse() 

    end while
    -- Closing main game
    HRMouse_pointer(0)      
    display_image({MainLogoPos[1]-30,1},MainBuf) -- Big Main Logo Image    
    display_image({10,10},ToolBarBuf) -- Clear the options bar
    Frame({10,10},{100,154},1) -- Options Bar
    display_image({20,20},ToolBarImg) -- Clear ToolBar
    HRMouse_pointer(1)      
    SkullAnim={}
    Score={1,1}
    Button=ButtonBuf -- restore main buttons
    ----------
end procedure       
procedure ProcessMainButton(integer idx)
    sequence ns
    atom AD
    Som(2)
    if idx=1 then
        StartNewGame=true
    elsif idx=4 then
        nill=PopUp({MouseX,MouseY},POPUP_YESNO,POPUPDIZ_YESNO)
        if nill=1 then
            SairJogo=true
        end if
    elsif idx=3 then
        nill=MsgBox(TXT_SOBRE,1)
    elsif idx=2 then
        nill=MsgBox(TXT_AJUDA,1)
    end if
end procedure
procedure ProcessMainMouse()
    integer Mbt1,Mbt2
    sequence sbt1
    Mbt1=0 Mbt2=0
            --- Code for a click
            if MouseB=2 then
                    Mbt1=CheckPressedButton()
                    if Mbt1 then ProcessMainButton(Mbt1) end if                    
            end if
            -- Code for mouse movement

                 Mbt1=CheckPressedButton() 
                 if Mbt1 then  -- was on a button
                    if compare(StatusText,BTN_MAIN[Mbt1][2]) then
                        Som(3)
                        StatusPut(BTN_MAIN[Mbt1][2],1)-- show diz
                    end if
                 else
                    if compare(StatusText,TXT_IDLEDIZ) then -- out of everything
                        StatusPut(TXT_IDLEDIZ,2) -- show diz
                    end if
                 end if                    
end procedure
procedure ProcessNewGameMouse()
    integer Mbt1,Mbt2
    sequence sbt1
    Mbt1=0 Mbt2=0
            --- Code for a click
            if MouseB=2 then
                    Mbt1=CheckPressedButton()
                    if Mbt1 then ProcessNewGameButton(Mbt1) end if                    
            end if
            -- Code for mouse movement

                 Mbt1=CheckPressedButton() 
                 if Mbt1 then  -- on a button
                    if compare(StatusText,BTN_NEWGAME[Mbt1][2]) then
                        Som(3)
                        StatusPut(BTN_NEWGAME[Mbt1][2],1)-- show diz
                    end if
                 else
                    if compare(StatusText,TXT_IDLEDIZ) then -- out of everyth                        
                        StatusPut(TXT_IDLEDIZ,2) -- show diz
                    end if
                 end if                    
end procedure
procedure ClearNewGame(sequence buf) -- clear new game window
    HRMouse_pointer(0)      
    display_image(MainLogoPos+{50,50},buf)
    HRMouse_pointer(1)      
end procedure
procedure NewGameMenu() -- show new game menu
    sequence BtnBuf,WndBuf
    ---------- Drawing code
    BtnBuf=Button         
    WndBuf=save_image(MainLogoPos+{50,50},MainLogoPos+{360,240})
    ResetButtons()
    Frame(MainLogoPos+{50,50},MainLogoPos+{360,240},1)
    DrawButton(MainLogoPos+{290,210},BTN_NEWGAME[1][1],BTN_NEWGAME[1][2],1)
    DrawButton(MainLogoPos+{220,210},BTN_NEWGAME[2][1],BTN_NEWGAME[2][2],2)

    BmpPuts(MainLogoPos+{90,70},"Player 1",1,1)
    BmpPuts(MainLogoPos+{260,70},"Player 2",1,1)
    
    merge_image(MainLogoPos+{65,65},GfxBmp[8][1])
    merge_image(MainLogoPos+{235,65},GfxBmp[8][2])

    DrawButton(MainLogoPos+{90,90},BTN_NEWGAME[3][1],BTN_NEWGAME[3][2],3)
    DrawButton(MainLogoPos+{260,90},BTN_NEWGAME[4][1],BTN_NEWGAME[4][2],4)    

    -- faces buf
    NewGamePBmpBuf={save_image(NewGamePBmpPos[1],NewGamePBmpPos[1]+{110,80}),
                    save_image(NewGamePBmpPos[2],NewGamePBmpPos[2]+{110,80})}
    -- draw two humans
    merge_image(NewGamePBmpPos[1],GfxBmp[11][1])
    merge_image(NewGamePBmpPos[2],GfxBmp[11][1])
    -- print two humans
    BmpPuts(MainLogoPos+{83,190},POPUP_NEWGAME_TYPE[1],2,1)
    BmpPuts(MainLogoPos+{240,190},POPUP_NEWGAME_TYPE[1],2,1)            

    -------------------------
    SairNewGame=false
-----------------------------

    while SairNewGame=false do 
            Event=HRM()
        if sequence(Event) then
            MouseX=Event[2]
            MouseY=Event[3]
            MouseB=Event[1]

            ProcessNewGameMouse() 
                              
            if StartMain=true then 
                SairNewGame=true StartMain=false 
                ClearNewGame(WndBuf) 
                Main() 
            end if
        end if
    end while
    HRMouse_pointer(0)      
    display_image(MainLogoPos+{50,50},WndBuf)
    HRMouse_pointer(1)      
    Button=BtnBuf
end procedure
procedure MainMenu()
    object code     

    SairJogo=false
    DrawMainMenu()

    HRM_init(MouseBuf)
-----------------------------

    while SairJogo=false do 
            Event=HRM() --  Update pointer, get events 

        if sequence(Event) then
            MouseX=Event[2]
            MouseY=Event[3]
            MouseB=Event[1]
            ProcessMainMouse()
            ---- Check for offline routines
            if StartNewGame=true then StartNewGame=false NewGameMenu() end if
        end if
    end while
end procedure
procedure LoadConfig()
end procedure       
procedure InitGlobal()
    cursor(NO_CURSOR)

    ReadCmdLine()
    clear_screen()                                    
    position(1,1)
    puts(1, "TRI " & TXT_VERSION & " - Copyright 1997 RNCSoft, All rights reserved...\n\n")
    bk_color(BLUE)
    puts(1,repeat(' ',80))
    position(3,1)
    puts(1," Starting:\n\n")
    bk_color(BLACK)
    puts(1, " Starting game...\n")
        InitVars()        
    puts(1, "  Game started.\n")
    puts(1, " Loading configurations...\n")
        LoadConfig()
    puts(1, "  Configurations loaded.\n")
    if Usevesa=true then                    
        puts(1, " Using VESA ...\n")
    end if

    puts(1, " Loading sounds, please wait...\n")
    InitSFX()
    puts(1, "  Sounds loaded.\n")

    puts(1, " Loading graphics, please wait...\n")
    InitGFX()
    puts(1, "  Graphics loaded.\n")

end procedure                    
procedure ShowIntro()
end procedure
procedure CloseScreen()
    bk_color(BLUE)
    position(1,1)
    puts(1,repeat(' ',80))
    bk_color(BLACK)
       
    for ax=1 to length(TXT_SOBRE) do
        position(2+ax,10)
        puts(1,TXT_SOBRE[ax])
    end for
    bk_color(BLUE)
    position(length(TXT_SOBRE)+3,1)
    puts(1,repeat(' ',80))
    bk_color(BLACK)
    
    position(24,1)
end procedure
--------------------- Game Start     ----------------------------------------
InitGlobal()
InitSVGA()             
ShowIntro()
MainMenu()
CloseSVGA()
CloseScreen()
abort(0)
-----------------------------------------------------------------------------

