sequence FontMaster
object mse
---------------------------------- Definitions ------------------------------
    FontMaster=
"0987654321\\?/}{\'Ƈւ\";:.><,+=-)(*&~$@!wzyxvutsrqponmlkjihgfedcbaWZYXVUTSRQPONMLKJIHGFEDCBA "
-----------------------------------------------------------------------------
global function ConcateBmp(sequence bmp,sequence new)             
    sequence binalbmp                                         
    binalbmp=bmp
    for ay=1 to length(bmp) do
        binalbmp[ay]=binalbmp[ay] & new[ay]
    end for
    return binalbmp
end function
global procedure ResetButtons()
    Button=repeat({},50) 
end procedure
global function CheckPressedButton()
    for ax=1 to length(Button) do
        if length(Button[ax]) >0 then
        if MouseX>Button[ax][1][1] and MouseX<Button[ax][1][3] and
           MouseY>Button[ax][1][2] and MouseY<Button[ax][1][4] then
           return ax                 
        end if
        end if
    end for
    return false
end function
global procedure BmpPuts(sequence p1,sequence txt,integer Fonte,integer Esp)
    integer ChrIdx
    sequence finalbmp
    if length(txt) =0 then return end if
    for ax=1 to length(txt) do
        if not find(txt[ax],FontMaster) then txt[ax]=' ' end if
    end for
    finalbmp=GfxBmp[4][Fonte][find(txt[1],FontMaster)]
    for ax=2 to length(txt) do
        ChrIdx=find(txt[ax],FontMaster)
        finalbmp=ConcateBmp(finalbmp,GfxBmp[4][Fonte][ChrIdx])
    end for                                                      
    merge_image(p1,finalbmp)
end procedure
global function ImgMount(sequence bmp,integer sX,integer sY)
    sequence tmpBmp,Mountnp
    integer tY

    tmpBmp=repeat({},sY)
    tY=1               
    for aY=1 to sY do
        for ax=1 to floor(sX/length(bmp[1])) do
            tmpBmp[aY]=tmpBmp[aY] & bmp[tY]
        end for                                        
        Mountnp=tmpBmp[aY][1..remainder(sX,length(bmp[1]))]
        tmpBmp[aY]=tmpBmp[aY] & Mountnp
        if tY=length(bmp) then tY=1 else tY=tY+1 end if
    end for
    return tmpBmp
end function
global function Mount(sequence bmp,integer tot,integer dir)
    sequence tmpBmp
    if dir=1 then
        tmpBmp=repeat(repeat(0,length(bmp[1])),(tot)*length(bmp))
    else
        tmpBmp=repeat(repeat(0,(tot)*length(bmp[1])),length(bmp))
    end if
    if dir=1 then    
        for ax=1 to tot do
            for av=1 to length(bmp[1]) do
                tmpBmp[ax][av]=bmp[1][av]
            end for        
        end for
    else
        for ax=1 to tot do
            for ah=1 to length(bmp) do
                tmpBmp[ah][ax]=bmp[ah][1]
            end for        
        end for
    end if
    return tmpBmp
end function
global procedure Frame(sequence p1,sequence p2,integer tip)
    integer FrameWidth,FrameHeight

    FrameWidth=p2[1]-p1[1]      FrameHeight=p2[2]-p1[2]

    if tip=1 then

        display_image({p1[1]+4,p1[2]+4},ImgMount(GfxBmp[1][2],
                       FrameWidth-6,FrameHeight-6))
    else
        Rect({p1[1]+5,p1[2]+7},{p2[1]-6,p2[2]-5},195,1)
    end if    
        display_image({p1[1]+9,p1[2]+1},Mount(GfxBmp[3][2],p2[1]-p1[1]-10,2))
        display_image({p1[1]+9,p2[2]-7},Mount(GfxBmp[3][7],p2[1]-p1[1]-10,2)) -- -10
                                   --6
        display_image({p1[1]+1,p1[2]+10},Mount(GfxBmp[3][4],p2[2]-p1[2]-11,1))
        display_image({p2[1]-6,p1[2]+10},Mount(GfxBmp[3][5],p2[2]-p1[2]-11,1))
    
        display_image({p1[1]+1,p1[2]+1},GfxBmp[3][1])
        display_image({p2[1]-9,p2[2]-10},GfxBmp[3][8])
        display_image({p2[1]-9,p1[2]+1},GfxBmp[3][3])
        display_image({p1[1]+1,p2[2]-10},GfxBmp[3][6])
end procedure
global procedure DrawButton(sequence pos,sequence txt,sequence diz,integer idx)
        Button[idx]={{pos[1],pos[2],pos[1]+58,pos[2]+17},
                      txt,diz,idx}
        display_image(pos,GfxBmp[5][1])
        BmpPuts({pos[1]+(28-floor(length(txt)*5/2)),pos[2]+2},txt,1,1)
end procedure
global function MsgBox(sequence Texto,integer Tipo)       
    integer FinalInt,MsgRows,MsgCols,MsgHeight,MsgWidth,KCode,
            AtualInputCol
    sequence FinalSeq,BoxPos,MsgBoxBuf,MsgResult,InputBuf,InputPos,TmpBtn

    MsgRows=length(Texto) MsgCols=length(Texto[MaiorElemento(Texto)])

    if Tipo=2 then MsgRows=MsgRows+1 end if -- bota mais 2 linhas, uma para
                                            -- espao e outra para a resposta
    MsgHeight=MsgRows*13 + 70 -- was +30
    MsgWidth=MsgCols*6 + 40                                          
    
    if MsgWidth < 2*73-10 then MsgWidth=2*73+15 end if
                                    --check if width is smaller than 2 buttons
    
    HRMouse_pointer(0)  -- some mouse

    BoxPos={320-floor(MsgWidth/2),240-floor(MsgHeight/2)}
    MsgBoxBuf=save_image(BoxPos,{320+floor(MsgWidth/2),240+floor(MsgHeight/2)})
    Frame(BoxPos,{320+floor(MsgWidth/2),240+floor(MsgHeight/2)},1) --1
    TmpBtn=Button -- store current buttons
    ResetButtons() -- clear actual buttons
    DrawButton({320+floor(MsgWidth/2),240+floor(MsgHeight/2)}-{2*73-6,25},
               "OK","OK",1)  -- draw "OK" button
    DrawButton({320+floor(MsgWidth/2),240+floor(MsgHeight/2)}-{73,25},
               "Cancel","Cancel",2) -- Draw "Cancel" button
    
    HRMouse_pointer(1)  -- aparece mouse
    if Tipo=1 then                  -- text box
        for ax=1 to length(Texto) do
            BmpPuts({BoxPos[1]+20,BoxPos[2]+20+(ax-1)*13},Texto[ax],1,1)
        end for
        FinalInt=3
        while FinalInt=3 do

            mse=HRM() --  Update pointer, get events 
            if sequence(mse) then
                MouseX=mse[2]
                MouseY=mse[3]
                MouseB=mse[1]
            end if

            if MouseB=2 then
                    nill=CheckPressedButton()
                    if nill=1 then 
                        FinalInt=true                        
                    elsif nill=2 then 
                        FinalInt=false
                    end if                    
            end if

            KCode=get_key()
            if KCode != -1 then
                if KCode=13 or KCode='s' or KCode='S' then
                    FinalInt=true
                elsif KCode=27 or KCode='N' or KCode='n' then        
                    FinalInt=false
                end if
            end if        
        end while
    elsif Tipo=2 then                   -- input box
        for ax=1 to length(Texto) do
            BmpPuts({BoxPos[1]+20,BoxPos[2]+20+(ax-1)*13},Texto[ax],1,1)
        end for

        InputPos={BoxPos[1]+20,BoxPos[2]+20+(length(Texto))*13}
        InputBuf=save_image(InputPos,{InputPos[1]+(MsgCols-1)*5,
                                      InputPos[2]+16})
        AtualInputCol=0
        MsgResult={}
        FinalInt=0

        while FinalInt=0 do
            mse=HRM() --  Update pointer, get events 
            if sequence(mse) then
                MouseX=mse[2]
                MouseY=mse[3]
                MouseB=mse[1]
            end if

            if MouseB=2 then
                    nill=CheckPressedButton()
                    if nill=1 then 
                        if length(MsgResult)<1 then
                             MsgResult={}
                        end if
                        FinalInt=1
                    elsif nill=2 then 
                         MsgResult={}
                         FinalInt=1
                    end if                    
            end if
            KCode=get_key()
            if KCode != -1 then
            if KCode=13 then
                if length(MsgResult)<1 then
                     MsgResult={}
                end if
                FinalInt=1
            elsif KCode=27 then        
                 MsgResult={}
                 FinalInt=1
            elsif KCode=8 then   
                 if AtualInputCol=0 then
                 else                      
                     AtualInputCol=AtualInputCol-1
                     MsgResult=MsgResult[1..AtualInputCol]
                     display_image(InputPos,InputBuf) -- clear prompt
                     BmpPuts(InputPos,MsgResult,4,1)  -- redraw atual answ
                    end if
            elsif KCode > 31 and KCode < 141 then -- was: else
                    if AtualInputCol<MsgCols+1 then-- FinalInt=1 end if                        
                        AtualInputCol=AtualInputCol+1
                        MsgResult=append(MsgResult,KCode)
                        BmpPuts(InputPos,MsgResult,4,1)  -- redraw atual answ
                    end if
            end if             
            end if
       end while                           
    end if                                            
    HRMouse_pointer(0)  --some mouse
    display_image(BoxPos,MsgBoxBuf)
    HRMouse_pointer(1)  -- aparece mouse  
    Button=TmpBtn -- restore current buttons
    if Tipo=1 then return FinalInt
    elsif Tipo=2 then return MsgResult
    end if
end function
global procedure StatusPut(sequence Txt,integer color)
    StatusText=Txt
    display_image(DizBarPos+{3,3},StatusBuf)
    if length(Txt)>1 then BmpPuts(DizBarPos+{3,3},Txt,color,1) end if
end procedure

global function PopUp(sequence pos,sequence Opts,sequence Dizs)
    integer PopUpWidth,PopUpHeight,final,MouseX,MouseY,MouseB,tmpI,
            lasttmpI
    sequence PopUpBuf
    object ev                                                      
    lasttmpI=1
    tmpI=0
    final=MaiorElemento(Opts)
    PopUpWidth=length(Opts[final])*7+30 -- 6=largura media da fonte
    PopUpHeight=length(Opts) * 13+18 -- 12=altura da fonte
    if pos[1]+PopUpWidth > 800 then pos[1]=800-PopUpWidth end if
    HRMouse_pointer(0) -- some mouse
    PopUpBuf=save_image(pos,pos+{PopUpWidth,PopUpHeight})
    Frame(pos,pos+{PopUpWidth,PopUpHeight},1) -- typo 2
    for ax=1 to length(Opts) do
        BmpPuts({pos[1]+floor(PopUpWidth/2-(length(Opts[ax])*6)/2),
                 10+pos[2]+(ax-1)*13},Opts[ax],1,1) -- 12=altura da fnt
    end for
    final=-1
    HRMouse_pointer(1)
    while final=-1 do
        ev=HRM()
        if sequence(ev) then                                          
            MouseX=ev[2]
            MouseY=ev[3]
            MouseB=ev[1]
            if MouseX>pos[1] and MouseX<pos[1]+PopUpWidth and
               MouseY>pos[2] and MouseY<pos[2]+PopUpHeight then
                 tmpI=floor((MouseY-pos[2]-10)/13)+1 -- 12=altura da fnt
                 if tmpI>0 and tmpI<=length(Opts) then
                    if tmpI != lasttmpI then
        HRMouse_pointer(0)
                        if lasttmpI != 0 then
        BmpPuts({pos[1]+floor(PopUpWidth/2-(length(Opts[lasttmpI])*6)/2),
                 10+pos[2]+(lasttmpI-1)*13},Opts[lasttmpI],1,1) -- 12=altura da fnt
        StatusPut("",2)-- limpa o status bar
                        end if
                 lasttmpI=tmpI               
        StatusPut(Dizs[tmpI],2)-- mostra a diz no status bar
        BmpPuts({pos[1]+floor(PopUpWidth/2-(length(Opts[tmpI])*6)/2),
                 10+pos[2]+(tmpI-1)*13},Opts[tmpI],3,1)
        HRMouse_pointer(1)                  
                    end if
                 end if
            else
                if lasttmpI != 0 then
        HRMouse_pointer(0)
        BmpPuts({pos[1]+floor(PopUpWidth/2-(length(Opts[lasttmpI])*6)/2),
                 10+pos[2]+(lasttmpI-1)*13},Opts[lasttmpI],1,1) -- 12=altura da fnt
                 lasttmpI=0          
        StatusPut("",2)-- limpa o status bar
        HRMouse_pointer(1)
                 end if
            end if
            if MouseB=2 then
                if MouseX>pos[1] and MouseX<pos[1]+PopUpWidth and
                   MouseY>pos[2] and MouseY<pos[2]+PopUpHeight then
                    final=floor((MouseY-pos[2]-10)/13)+1 -- 12=altura da fnt
                else
                    final=0
                end if
            end if
        end if
    end while              
    HRMouse_pointer(0)
    display_image(pos,PopUpBuf)
    HRMouse_pointer(1)
    return final
end function

